/**
 * Name: Texture.h
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#include <stdio.h>										
#ifdef __APPLE__
#include <OpenGL/gl.h>
#else
	#include <GL/glut.h>
#endif	

/*
* The idea of this way of creating a Texture came from Alex Kamisky. 
* It has been changed to fit into this ParticleSystem implementation.
* @author Hannes Ricklefs
*/

//! The texture struct
/**
* Creates a struct for a Texture. 
*/
typedef	struct									
{	
	/**
	* Image Data (Up To 32 Bits)
	*/
	GLubyte	* imageData;									 
	/**
	* Image Color Depth In Bits Per Pixel
	*/ 
	GLuint	bpp;											
	/**
	* Image Width
	*/
	GLuint	width;										
	/**
	* Image Height
	*/
	GLuint	height;											
	/**
	* Texture ID Used To Select A Texture
	*/
	GLuint	texID;											
	/**
	* Image Type (GL_RGB, GL_RGBA)
	*/
	GLuint	type;										 
} Texture;	

#endif

