/**
 * Name: CollisionSphere.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "CollisionSphere.h"


using namespace GraphicsLib;
using namespace ParticleSystems; 

CollisionSphere::CollisionSphere( Point3 *p1, Real r) : CollisionObject() {
		position = p1;
		radius = r;
}
			
CollisionSphere::~CollisionSphere() {
	//free the position pointer
}

void CollisionSphere::collide(Particle *p) {
	// the relative position of the spheres
	Vector relPos;
	//min an max distances of the spheres
	GLfloat dist;
	float minDist;
	relPos = position-(p->position);

	// and the distance
	dist=relPos.x * relPos.x + relPos.y * relPos.y + relPos.z * relPos.z;
	minDist =radius+(p->size);
	// if it is a hit
	if(dist <=(minDist * minDist)) {
		#ifdef __COLLISION_SPHERE__
            std::cout << "Collision"<< std::endl;
         #endif
		 //Change the velocity of the Particle 
		 (p->velocity).x-=((p->bounce)*(p->velocity).x);
		 (p->velocity).y-=((p->bounce)*(p->velocity).y);
		 (p->velocity).z-=((p->bounce)*(p->velocity).z);
	}else {
		#ifdef __COLLISION_SPHERE_
            //std::cout << "New Velocity " << p->velocity<< std::endl;
         #endif
	}
}

void CollisionSphere::draw() {
	// preserve the tx matrix
	glPushMatrix();
		// translate to the particle position
		position.Translate();
		//colour.Use();
		glutSolidSphere(radius,10,10);
	glPopMatrix();
	
}

void CollisionSphere::translate() {
	std::cout << "Method not yet implemented" << std::endl;
}
void CollisionSphere::rotate() {
	std::cout << "Method not yet implemented" << std::endl;
}
void CollisionSphere::scale() {
	std::cout << "Method not yet implemented" << std::endl;
}

