/**
 * Name: Emitter.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "Emitter.h"
using namespace GraphicsLib;
using namespace ParticleSystems;

Emitter::Emitter(	int SYSID, 
					Solver *s, 
					PARTICLETYPE t, 
					Vector initVel, 
					Colour initColor, 
					GLfloat pSize) {
	SYSID = SYSID;
	solver = s;
	initialVelocity = initVel;
	initialColor = initColor;
	particleSize = pSize;
	type = t;
	initEmitter();
} 

Emitter::Emitter(	int SYSID, 
					Solver *s, 
					PARTICLETYPE t, 
					Vector initVel, 
					Colour initColor, 
					GLfloat pSize,
					char *TexName) {
	SYSID = SYSID;
	solver = s;
	type = t;
	initialVelocity = initVel;
	initialColor = initColor;
    loader = new TGALoader();
	particleSize = pSize;
	loader->LoadTGA(&texture,TexName);
	initEmitter();
}


Emitter::~Emitter() {
}

void Emitter::initEmitter() {
	//default values
	particleSizeFlare = 0.00;
	Colour *flare = new Colour(0.00,0.00,0.00,0.00);
	flare->set(0.00,0.00,0.00,0.00);
	flareColor = (*flare);
	delete flare;
	particleLife = 30;
}

