/**
 * Name: GravityForce.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "GravityForce.h"
using namespace GraphicsLib;
using namespace ParticleSystems;
GravityForce::GravityForce(Vector *f, float a, float m) : Force(f,a) {
	magnitude = m;
}

GravityForce::~GravityForce() {
	delete force;
}

void GravityForce::applyForce(Vector *direction) {
	//if attenuation == 1 apply it fully
	if(attenuation) {
		(*direction).x += magnitude * (*force).x;
		(*direction).y += magnitude * (*force).y;
		(*direction).z += magnitude * (*force).z;
		(*direction).w += magnitude * (*force).w;
	} else {
		(*direction).x += magnitude * (attenuation *  RandomPosNum((*force).x));
		(*direction).y += magnitude * (attenuation *  RandomPosNum((*force).y));
		(*direction).z += magnitude * (attenuation *  RandomPosNum((*force).z));
		(*direction).w += magnitude * (attenuation *  RandomPosNum((*force).w));
	}
}

void GravityForce::applyForce(Vector *direction, float *mass) {
	//if attenuation == 1 apply it fully
	if(attenuation) {
		(*direction)+=magnitude *(*force)/(*mass);
	} else {
		(*direction).x += magnitude * (attenuation * RandomPosNum((*force).x)/(*mass));
		(*direction).y += magnitude * (attenuation * RandomPosNum((*force).y)/(*mass));
		(*direction).z += magnitude * (attenuation * RandomPosNum((*force).z)/(*mass));
		(*direction).w += magnitude * (attenuation * RandomPosNum((*force).w)/(*mass));
	}
}
