/**
 * Name: Particle.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "Particle.h"

using namespace ParticleSystems;
using namespace GraphicsLib;

Particle::Particle( int sysId,
					GraphicsLib::Point3 pos,
                    GraphicsLib::Vector vel,
                    GraphicsLib::Colour c,
                    GLfloat trans,
                    float b,
                    float ma,
                    float mo,
                    float e,
                    float s
                ) {
    SYSID = sysId;
	position = pos;
    velocity = vel;
    colour = c;
    transparency = trans;
    bounce = b;
    mass = ma;
    momentum = mo;
    energy = e;
    size = s;
	dead = false;
}

Particle::Particle( int sysId,
					Solver *sol,
					GraphicsLib::Point3 pos,
                    GraphicsLib::Vector vel,
                    GraphicsLib::Colour c,
					GraphicsLib::Colour fc,
					GLfloat s,
					GLfloat fs,
					GLfloat maxLife
                ) {
	SYSID = sysId;
    position = pos;
	old_Position = position;
    velocity = vel;
    solv = sol;
	colour = c;
	faded_colour = fc;
	size = s;
	flare_size = fs;
	MAXLIFE = maxLife;
	dead = false;
	bounce = 2.0f;
	//flare_size = 0.02f;
}


Particle::Particle(int sysId, Solver *sol) {
	size = 0.05;
	SYSID = sysId;
	solv = sol;
	position = new Point3( RandomNum(1.0f),RandomNum(1.0f),RandomNum(1.0f));
	old_Position = position;
    velocity.set(0.1f,0.1f,0.0f);
	colour.set(0.5,0.5,0.5);
	MAXLIFE = RandomPosNum(30);
	dead = false;
}

Particle::~Particle() {
}
