/**
 * Name: PointParticle.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "PointParticle.h"
#include <iostream>

using namespace std;
using namespace ParticleSystems;
using namespace GraphicsLib;


PointParticle::PointParticle(int sysId, Solver *sol) : Particle(sysId,sol) {
	//position = new Point3(0,0,0);
	//direction = new Vector(0,0,0);

}

PointParticle::PointParticle(	int sysId, 
								Solver *sol, 
								Point3 pos, 
								Vector vel, 
								Colour c, 
								Colour fc,
								GLfloat size,
								GLfloat fs, 
								GLfloat ml) : Particle(sysId, sol, pos, vel, c,fc, size,fs, ml) {
	
}

void PointParticle::draw(void) {
	// preserve the tx matrix
	glPushMatrix();
		// translate to the particle position
		position.Translate();
		colour.Use();
		//draw a sphere with the specified size
		glutSolidSphere(size,15,15);
	glPopMatrix();
}

void PointParticle::update(void) {
	//Update the vector
	Vector *tmp = &velocity;
	solv->nextStep(tmp);
	#ifdef __COLLISION__
            std::cout << "In particle " << position<< std::endl;
	#endif
	position+=velocity;
	size -= flare_size;
	colour = colour - faded_colour;
	life+=1.0;
	if(life>MAXLIFE) {
		dead = true;
	}
	#ifdef __COLLISION__
            std::cout << "In particle new" << position<< std::endl;
	#endif
}

bool PointParticle::isDead() {
	return dead;
}

PointParticle::~PointParticle() {

}
