/**
 * Name: StraightSolver.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "StraightSolver.h"
#include <algorithm>
using namespace ParticleSystems;
using namespace GraphicsLib;

StraightSolver::StraightSolver(Force *f) : Solver(f) {
}

StraightSolver::StraightSolver() : Solver() {
}

StraightSolver::~StraightSolver() {
}


void StraightSolver::nextStep(Vector *direction) {
	forcesItt = forces.begin();
	while(forcesItt != forces.end()) {
		//Apply the forces to the direction
		(*forcesItt)->applyForce(direction);
		forcesItt++;
	}
}

void StraightSolver::nextStep(Vector *direction, float *mass) {
	forcesItt = forces.begin();
	while(forcesItt != forces.end()) {
		//Apply the forces to direction incooperating the mass
		(*forcesItt)->applyForce(direction, mass);
		forcesItt++;
	}
}

