/**
 * Name: UniformForce.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "UniformForce.h"
using namespace GraphicsLib;
using namespace ParticleSystems;
UniformForce::UniformForce(Vector *f, float a) : Force(f,a) {
}

UniformForce::~UniformForce() {
	delete force;
}

void UniformForce::applyForce(Vector *direction) {
	//if attenuation == 1 apply it fully
	if(attenuation) {
		(*direction).x += (*force).x;
		(*direction).y += (*force).y;
		(*direction).z += (*force).z;
		(*direction).w += (*force).w;
	} else {
		(*direction).x += (attenuation * (*force).x);
		(*direction).y += (attenuation * (*force).y);
		(*direction).z += (attenuation * (*force).z);
		(*direction).w += (attenuation * (*force).w);
	}
}

void UniformForce::applyForce(Vector *direction, float *mass) {
	//if attenuation == 1 apply it fully
	if(attenuation) {
		(*direction)+=(*force)/(*mass);
	} else {
		(*direction).x += (attenuation * (*force).x)/(*mass);
		(*direction).y += (attenuation * (*force).y)/(*mass);
		(*direction).z += (attenuation * (*force).z)/(*mass);
		(*direction).w += (attenuation * (*force).w)/(*mass);
	}
}
