/**
 * Name: VectorDS.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "VectorDS.h"

using namespace std;
using namespace ParticleSystems;
using namespace GraphicsLib;

VectorDS::VectorDS() : DataStructure() {
}

VectorDS::~VectorDS() {
}

void VectorDS::addParticles(Particle *particle) {
	particles.insert(particles.begin(), particle);
}

void VectorDS::killParticles() {
	particles.erase(particles.begin(), particles.end());
}

void VectorDS::evolve() {
	pAllItt itt = particles.begin();
	pAllItt end = particles.end();
    #ifdef __PERFORMANCE__
    std::cout << "VectorDS: Before evolve"  << std::endl;
    #endif
	while(itt != end) {
        //Check if collision is enabled
        if(collision) {
            allcObjects itt2 = collisionObjects.begin();
	        //allcObjects end2 = collisionObjects.end();
            int size = collisionObjects.size();
            for(int i = 0; i < size; i++) {
                #ifdef __COLLISION__
                    std::cout << collisionObjects.size() << std::endl;
					std::cout << " VectorDS: particle position vectords before" << (*itt)->position << std::endl;
					
                #endif
		        (*itt2)->collide((*itt));
		        itt2++;
	        }
        }
		(*itt)->update();

        if((*itt)->isDead() && deadParticles.size() < storageCapacity) {
			deadParticles.insert(deadParticles.begin(), (*itt));
		}
		#ifdef __COLLISION__
		std::cout << "VectorDS: Particle position vectords after" << " " << (*itt)->position << std::endl;
		#endif
		itt++;

	}
    #ifdef __PERFORMANCE__
    std::cout << "VectorDS: End evolve"  << std::endl;
    #endif
	#ifdef  __PARTICLE_GENERATION__
	std::cout << this->size()  << std::endl;
	#endif
}

bool VectorDS::positionCheck(GraphicsLib::Point3 pos) {
	return true;
}

void VectorDS::draw() {

    pAllItt itt = particles.begin();
	pAllItt end = particles.end();
    #ifdef __PERFORMANCE__
        cout << "VectorDS: beforedrawing particles" << endl;
    #endif


	while(itt != end) {


		(*itt)->draw();
		itt++;
	}

    #ifdef __PERFORMANCE__"ParticleSystem.cpp"
        cout << "VectorDS: afterdrawing particles" << endl;
    #endif
    allcObjects itt2 = collisionObjects.begin();
	allcObjects end2 = collisionObjects.end();
	while(itt2 != end2) {
		(*itt2)->draw();
		itt2++;
	}
	
    #ifdef __PERFORMANCE__
    std::cout << size()  << std::endl;
    #endif
}

int VectorDS::numParticles() {
	return particles.size();
}

bool VectorDS::hasDead() {
	return !(deadParticles.empty());
}

Particle* VectorDS::getDead() {
    #ifdef __PERFORMANCE__
    std::cout << "VectorDS: Before getting DeadParticles"  << std::endl;
    #endif
	allDeadItt itt = deadParticles.begin();
	#ifdef  __PARTICLE_GENERATION__
	std::cout << "VectorDS: before deletion " << deadParticles.size()  << std::endl;
	#endif
	deadParticles.erase(itt);
	#ifdef  __PARTICLE_GENERATION__
	std::cout << "VectorDS: after deletion " << deadParticles.size()  << std::endl;
	#endif
     #ifdef __PERFORMANCE__
    std::cout << "VectorDS: Before after DeadParticles"  << std::endl;
    #endif
	return (*itt);
	
}

void VectorDS::addCollisionObject(CollisionObject *co){
    collisionObjects.insert(collisionObjects.begin(), co);
}

void VectorDS::deleteCollisionObject(CollisionObject *co){

}

